diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-enb-net-device.cc ns-3.31/src/lte/model/lte-enb-net-device.cc
--- ns-3.30.1/src/lte/model/lte-enb-net-device.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-enb-net-device.cc	2020-06-27 17:38:30.000000000 -0700
@@ -239,16 +239,16 @@
   return false;
 }
 
-uint8_t 
+uint16_t
 LteEnbNetDevice::GetUlBandwidth () const
 {
   return m_ulBandwidth;
 }
 
 void 
-LteEnbNetDevice::SetUlBandwidth (uint8_t bw)
+LteEnbNetDevice::SetUlBandwidth (uint16_t bw)
 { 
-  NS_LOG_FUNCTION (this << uint16_t (bw));
+  NS_LOG_FUNCTION (this << bw);
   switch (bw)
     { 
     case 6:
@@ -261,19 +261,19 @@
       break;
 
     default:
-      NS_FATAL_ERROR ("invalid bandwidth value " << (uint16_t) bw);
+      NS_FATAL_ERROR ("invalid bandwidth value " << bw);
       break;
     }
 }
 
-uint8_t 
+uint16_t
 LteEnbNetDevice::GetDlBandwidth () const
 {
   return m_dlBandwidth;
 }
 
 void 
-LteEnbNetDevice::SetDlBandwidth (uint8_t bw)
+LteEnbNetDevice::SetDlBandwidth (uint16_t bw)
 {
   NS_LOG_FUNCTION (this << uint16_t (bw));
   switch (bw)
@@ -288,7 +288,7 @@
       break;
 
     default:
-      NS_FATAL_ERROR ("invalid bandwidth value " << (uint16_t) bw);
+      NS_FATAL_ERROR ("invalid bandwidth value " << bw);
       break;
     }
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-enb-net-device.h ns-3.31/src/lte/model/lte-enb-net-device.h
--- ns-3.30.1/src/lte/model/lte-enb-net-device.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-enb-net-device.h	2020-06-27 17:38:30.000000000 -0700
@@ -116,22 +116,22 @@
   /** 
    * \return the uplink bandwidth in RBs
    */
-  uint8_t GetUlBandwidth () const;
+  uint16_t GetUlBandwidth () const;
 
   /** 
    * \param bw the uplink bandwidth in RBs
    */
-  void SetUlBandwidth (uint8_t bw);
+  void SetUlBandwidth (uint16_t bw);
 
   /** 
    * \return the downlink bandwidth in RBs
    */
-  uint8_t GetDlBandwidth () const;
+  uint16_t GetDlBandwidth () const;
 
   /** 
    * \param bw the downlink bandwidth in RBs
    */
-  void SetDlBandwidth (uint8_t bw);
+  void SetDlBandwidth (uint16_t bw);
 
   /** 
    * \return the downlink carrier frequency (EARFCN)
@@ -244,8 +244,8 @@
 
   uint16_t m_cellId; /**< Cell Identifier. Part of the CGI, see TS 29.274, section 8.21.1  */
 
-  uint8_t m_dlBandwidth; /**<DEPRECATE - It is maintained for backward compatibility after adding CA feature- downlink bandwidth in RBs */
-  uint8_t m_ulBandwidth; /**<DEPRECATE - It is maintained for backward compatibility after adding CA feature- uplink bandwidth in RBs */
+  uint16_t m_dlBandwidth; /**<DEPRECATE - It is maintained for backward compatibility after adding CA feature- downlink bandwidth in RBs */
+  uint16_t m_ulBandwidth; /**<DEPRECATE - It is maintained for backward compatibility after adding CA feature- uplink bandwidth in RBs */
 
   uint32_t m_dlEarfcn;  /**<DEPRECATE - It is maintained for backward compatibility after adding CA feature- downlink carrier frequency */
   uint32_t m_ulEarfcn;  /**<DEPRECATE - It is maintained for backward compatibility after adding CA feature- uplink carrier frequency */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-enb-phy.cc ns-3.31/src/lte/model/lte-enb-phy.cc
--- ns-3.30.1/src/lte/model/lte-enb-phy.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-enb-phy.cc	2020-06-27 17:38:30.000000000 -0700
@@ -91,7 +91,7 @@
    * \param ulBandwidth the UL bandwidth
    * \param dlBandwidth the DL bandwidth
    */
-  virtual void SetBandwidth (uint8_t ulBandwidth, uint8_t dlBandwidth);
+  virtual void SetBandwidth (uint16_t ulBandwidth, uint16_t dlBandwidth);
   /**
    * Set Cell ID function
    *
@@ -116,7 +116,7 @@
 }
 
 void
-EnbMemberLteEnbPhySapProvider::SetBandwidth (uint8_t ulBandwidth, uint8_t dlBandwidth)
+EnbMemberLteEnbPhySapProvider::SetBandwidth (uint16_t ulBandwidth, uint16_t dlBandwidth)
 {
   m_phy->DoSetBandwidth (ulBandwidth, dlBandwidth);
 }
@@ -894,7 +894,7 @@
 
 
 void
-LteEnbPhy::DoSetBandwidth (uint8_t ulBandwidth, uint8_t dlBandwidth)
+LteEnbPhy::DoSetBandwidth (uint16_t ulBandwidth, uint16_t dlBandwidth)
 {
   NS_LOG_FUNCTION (this << (uint32_t) ulBandwidth << (uint32_t) dlBandwidth);
   m_ulBandwidth = ulBandwidth;
@@ -1171,7 +1171,7 @@
 
 
 void
-LteEnbPhy::ReceiveLteUlHarqFeedback (UlInfoListElement_s mes)
+LteEnbPhy::ReportUlHarqFeedback (UlInfoListElement_s mes)
 {
   NS_LOG_FUNCTION (this);
   // forward to scheduler
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-enb-rrc.cc ns-3.31/src/lte/model/lte-enb-rrc.cc
--- ns-3.30.1/src/lte/model/lte-enb-rrc.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-enb-rrc.cc	2020-06-27 17:38:30.000000000 -0700
@@ -2175,11 +2175,11 @@
 {
   auto it = ccPhyConf.begin ();
   NS_ASSERT (it != ccPhyConf.end ());
-  uint8_t ulBandwidth = it->second->GetUlBandwidth ();
-  uint8_t dlBandwidth = it->second->GetDlBandwidth ();
+  uint16_t ulBandwidth = it->second->GetUlBandwidth ();
+  uint16_t dlBandwidth = it->second->GetDlBandwidth ();
   uint32_t ulEarfcn = it->second->GetUlEarfcn ();
   uint32_t dlEarfcn = it->second->GetDlEarfcn ();
-  NS_LOG_FUNCTION (this << (uint16_t) ulBandwidth << (uint16_t) dlBandwidth
+  NS_LOG_FUNCTION (this << ulBandwidth << dlBandwidth
                         << ulEarfcn << dlEarfcn);
   NS_ASSERT (!m_configured);
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-enb-rrc.h ns-3.31/src/lte/model/lte-enb-rrc.h
--- ns-3.30.1/src/lte/model/lte-enb-rrc.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-enb-rrc.h	2020-06-27 17:38:30.000000000 -0700
@@ -559,7 +559,7 @@
   /**
    * The `DrbCreated` trace source. Fired when DRB is created, i.e.
    * the RLC and PDCP entities are created for one logical channel.
-   * Exporting IMSI, cell ID, RNTI, and LCID
+   * Exporting IMSI, cell ID, RNTI, LCID.
    */
   TracedCallback<uint64_t, uint16_t, uint16_t, uint8_t> m_drbCreatedTrace;
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-ffr-algorithm.cc ns-3.31/src/lte/model/lte-ffr-algorithm.cc
--- ns-3.30.1/src/lte/model/lte-ffr-algorithm.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-ffr-algorithm.cc	2020-06-27 17:38:30.000000000 -0700
@@ -79,7 +79,7 @@
   NS_LOG_FUNCTION (this);
 }
 
-uint8_t
+uint16_t
 LteFfrAlgorithm::GetUlBandwidth () const
 {
   NS_LOG_FUNCTION (this);
@@ -87,9 +87,9 @@
 }
 
 void
-LteFfrAlgorithm::SetUlBandwidth (uint8_t bw)
+LteFfrAlgorithm::SetUlBandwidth (uint16_t bw)
 {
-  NS_LOG_FUNCTION (this << uint16_t (bw));
+  NS_LOG_FUNCTION (this << bw);
   switch (bw)
     {
     case 6:
@@ -102,12 +102,12 @@
       break;
 
     default:
-      NS_FATAL_ERROR ("invalid bandwidth value " << (uint16_t) bw);
+      NS_FATAL_ERROR ("invalid bandwidth value " <<  bw);
       break;
     }
 }
 
-uint8_t
+uint16_t
 LteFfrAlgorithm::GetDlBandwidth () const
 {
   NS_LOG_FUNCTION (this);
@@ -115,9 +115,9 @@
 }
 
 void
-LteFfrAlgorithm::SetDlBandwidth (uint8_t bw)
+LteFfrAlgorithm::SetDlBandwidth (uint16_t bw)
 {
-  NS_LOG_FUNCTION (this << uint16_t (bw));
+  NS_LOG_FUNCTION (this << bw);
   switch (bw)
     {
     case 6:
@@ -130,7 +130,7 @@
       break;
 
     default:
-      NS_FATAL_ERROR ("invalid bandwidth value " << (uint16_t) bw);
+      NS_FATAL_ERROR ("invalid bandwidth value " << bw);
       break;
     }
 }
@@ -172,7 +172,7 @@
 }
 
 void
-LteFfrAlgorithm::DoSetBandwidth (uint8_t ulBandwidth, uint8_t dlBandwidth)
+LteFfrAlgorithm::DoSetBandwidth (uint16_t ulBandwidth, uint16_t dlBandwidth)
 {
   NS_LOG_FUNCTION (this);
   SetDlBandwidth (dlBandwidth);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-ffr-algorithm.h ns-3.31/src/lte/model/lte-ffr-algorithm.h
--- ns-3.30.1/src/lte/model/lte-ffr-algorithm.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-ffr-algorithm.h	2020-06-27 17:38:30.000000000 -0700
@@ -99,22 +99,22 @@
   /**
    * \return the uplink bandwidth in RBs
    */
-  uint8_t GetUlBandwidth () const;
+  uint16_t GetUlBandwidth () const;
 
   /**
    * \param bw the uplink bandwidth in RBs
    */
-  void SetUlBandwidth (uint8_t bw);
+  void SetUlBandwidth (uint16_t bw);
 
   /**
    * \return the downlink bandwidth in RBs
    */
-  uint8_t GetDlBandwidth () const;
+  uint16_t GetDlBandwidth () const;
 
   /**
    * \param bw the downlink bandwidth in RBs
    */
-  void SetDlBandwidth (uint8_t bw);
+  void SetDlBandwidth (uint16_t bw);
 
   /**
    * \param cellTypeId for automatic FR configuration
@@ -202,7 +202,7 @@
    * \brief DoGetMinContinuousUlBandwidth in number of RB
    * \return number of RB in min continuous UL Bandwidth
    */
-  virtual uint8_t DoGetMinContinuousUlBandwidth () = 0;
+  virtual uint16_t DoGetMinContinuousUlBandwidth () = 0;
 
   // FFR SAP RRC PROVIDER IMPLEMENTATION
 
@@ -217,7 +217,7 @@
    * \param ulBandwidth UL bandwidth in number of RB
    * \param dlBandwidth DL bandwidth in number of RB
    */
-  virtual void DoSetBandwidth (uint8_t ulBandwidth, uint8_t dlBandwidth);
+  virtual void DoSetBandwidth (uint16_t ulBandwidth, uint16_t dlBandwidth);
 
   /**
    * \brief Implementation of LteFfrRrcSapProvider::ReportUeMeas.
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-ffr-distributed-algorithm.cc ns-3.31/src/lte/model/lte-ffr-distributed-algorithm.cc
--- ns-3.30.1/src/lte/model/lte-ffr-distributed-algorithm.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-ffr-distributed-algorithm.cc	2020-06-27 17:38:30.000000000 -0700
@@ -365,7 +365,7 @@
   return 1;
 }
 
-uint8_t
+uint16_t
 LteFfrDistributedAlgorithm::DoGetMinContinuousUlBandwidth ()
 {
   NS_LOG_FUNCTION (this);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-ffr-distributed-algorithm.h ns-3.31/src/lte/model/lte-ffr-distributed-algorithm.h
--- ns-3.30.1/src/lte/model/lte-ffr-distributed-algorithm.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-ffr-distributed-algorithm.h	2020-06-27 17:38:30.000000000 -0700
@@ -72,7 +72,7 @@
   virtual void DoReportUlCqiInfo (const struct FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params);
   virtual void DoReportUlCqiInfo ( std::map <uint16_t, std::vector <double> > ulCqiMap );
   virtual uint8_t DoGetTpc (uint16_t rnti);
-  virtual uint8_t DoGetMinContinuousUlBandwidth ();
+  virtual uint16_t DoGetMinContinuousUlBandwidth ();
 
   // FFR SAP RRC PROVIDER IMPLEMENTATION
   virtual void DoReportUeMeas (uint16_t rnti, LteRrcSap::MeasResults measResults);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-ffr-enhanced-algorithm.cc ns-3.31/src/lte/model/lte-ffr-enhanced-algorithm.cc
--- ns-3.30.1/src/lte/model/lte-ffr-enhanced-algorithm.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-ffr-enhanced-algorithm.cc	2020-06-27 17:38:30.000000000 -0700
@@ -831,7 +831,7 @@
   return 1;
 }
 
-uint8_t
+uint16_t
 LteFfrEnhancedAlgorithm::DoGetMinContinuousUlBandwidth ()
 {
   NS_LOG_FUNCTION (this);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-ffr-enhanced-algorithm.h ns-3.31/src/lte/model/lte-ffr-enhanced-algorithm.h
--- ns-3.30.1/src/lte/model/lte-ffr-enhanced-algorithm.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-ffr-enhanced-algorithm.h	2020-06-27 17:38:30.000000000 -0700
@@ -80,7 +80,7 @@
   virtual void DoReportUlCqiInfo (const struct FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params);
   virtual void DoReportUlCqiInfo ( std::map <uint16_t, std::vector <double> > ulCqiMap );
   virtual uint8_t DoGetTpc (uint16_t rnti);
-  virtual uint8_t DoGetMinContinuousUlBandwidth ();
+  virtual uint16_t DoGetMinContinuousUlBandwidth ();
 
   // FFR SAP RRC PROVIDER IMPLEMENTATION
   virtual void DoReportUeMeas (uint16_t rnti, LteRrcSap::MeasResults measResults);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-ffr-sap.h ns-3.31/src/lte/model/lte-ffr-sap.h
--- ns-3.30.1/src/lte/model/lte-ffr-sap.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-ffr-sap.h	2020-06-27 17:38:30.000000000 -0700
@@ -124,7 +124,7 @@
    * \brief Get the minimum continuous Ul bandwidth
    * \returns the minimum continuous UL bandwidth
    */
-  virtual uint8_t GetMinContinuousUlBandwidth () = 0;
+  virtual uint16_t GetMinContinuousUlBandwidth () = 0;
 }; // end of class LteFfrSapProvider
 
 
@@ -168,7 +168,7 @@
   virtual void ReportUlCqiInfo (const struct FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params);
   virtual void ReportUlCqiInfo ( std::map <uint16_t, std::vector <double> > ulCqiMap );
   virtual uint8_t GetTpc (uint16_t rnti);
-  virtual uint8_t GetMinContinuousUlBandwidth ();
+  virtual uint16_t GetMinContinuousUlBandwidth ();
 private:
   MemberLteFfrSapProvider ();
   C* m_owner; ///< the owner class
@@ -240,7 +240,7 @@
 }
 
 template <class C>
-uint8_t
+uint16_t
 MemberLteFfrSapProvider<C>::GetMinContinuousUlBandwidth ()
 {
   return m_owner->DoGetMinContinuousUlBandwidth ();
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-ffr-soft-algorithm.cc ns-3.31/src/lte/model/lte-ffr-soft-algorithm.cc
--- ns-3.30.1/src/lte/model/lte-ffr-soft-algorithm.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-ffr-soft-algorithm.cc	2020-06-27 17:38:30.000000000 -0700
@@ -569,7 +569,7 @@
   return 1;
 }
 
-uint8_t
+uint16_t
 LteFfrSoftAlgorithm::DoGetMinContinuousUlBandwidth ()
 {
   NS_LOG_FUNCTION (this);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-ffr-soft-algorithm.h ns-3.31/src/lte/model/lte-ffr-soft-algorithm.h
--- ns-3.30.1/src/lte/model/lte-ffr-soft-algorithm.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-ffr-soft-algorithm.h	2020-06-27 17:38:30.000000000 -0700
@@ -78,7 +78,7 @@
   virtual void DoReportUlCqiInfo (const struct FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params);
   virtual void DoReportUlCqiInfo ( std::map <uint16_t, std::vector <double> > ulCqiMap );
   virtual uint8_t DoGetTpc (uint16_t rnti);
-  virtual uint8_t DoGetMinContinuousUlBandwidth ();
+  virtual uint16_t DoGetMinContinuousUlBandwidth ();
 
   // FFR SAP RRC PROVIDER IMPLEMENTATION
   virtual void DoReportUeMeas (uint16_t rnti, LteRrcSap::MeasResults measResults);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-fr-hard-algorithm.cc ns-3.31/src/lte/model/lte-fr-hard-algorithm.cc
--- ns-3.30.1/src/lte/model/lte-fr-hard-algorithm.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-fr-hard-algorithm.cc	2020-06-27 17:38:30.000000000 -0700
@@ -359,7 +359,7 @@
   return 1; // 1 is mapped to 0 for Accumulated mode, and to -1 in Absolute mode TS36.213 Table 5.1.1.1-2
 }
 
-uint8_t
+uint16_t
 LteFrHardAlgorithm::DoGetMinContinuousUlBandwidth ()
 {
   NS_LOG_FUNCTION (this);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-fr-hard-algorithm.h ns-3.31/src/lte/model/lte-fr-hard-algorithm.h
--- ns-3.30.1/src/lte/model/lte-fr-hard-algorithm.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-fr-hard-algorithm.h	2020-06-27 17:38:30.000000000 -0700
@@ -77,7 +77,7 @@
   virtual void DoReportUlCqiInfo (const struct FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params);
   virtual void DoReportUlCqiInfo ( std::map <uint16_t, std::vector <double> > ulCqiMap );
   virtual uint8_t DoGetTpc (uint16_t rnti);
-  virtual uint8_t DoGetMinContinuousUlBandwidth ();
+  virtual uint16_t DoGetMinContinuousUlBandwidth ();
 
   // FFR SAP RRC PROVIDER IMPLEMENTATION
   virtual void DoReportUeMeas (uint16_t rnti, LteRrcSap::MeasResults measResults);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-fr-no-op-algorithm.cc ns-3.31/src/lte/model/lte-fr-no-op-algorithm.cc
--- ns-3.30.1/src/lte/model/lte-fr-no-op-algorithm.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-fr-no-op-algorithm.cc	2020-06-27 17:38:30.000000000 -0700
@@ -170,7 +170,7 @@
   return 1; // 1 is mapped to 0 for Accumulated mode, and to -1 in Absolute mode TS36.213 Table 5.1.1.1-2
 }
 
-uint8_t
+uint16_t
 LteFrNoOpAlgorithm::DoGetMinContinuousUlBandwidth ()
 {
   NS_LOG_FUNCTION (this);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-fr-no-op-algorithm.h ns-3.31/src/lte/model/lte-fr-no-op-algorithm.h
--- ns-3.30.1/src/lte/model/lte-fr-no-op-algorithm.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-fr-no-op-algorithm.h	2020-06-27 17:38:30.000000000 -0700
@@ -83,7 +83,7 @@
   virtual void DoReportUlCqiInfo (const struct FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params);
   virtual void DoReportUlCqiInfo ( std::map <uint16_t, std::vector <double> > ulCqiMap );
   virtual uint8_t DoGetTpc (uint16_t rnti);
-  virtual uint8_t DoGetMinContinuousUlBandwidth ();
+  virtual uint16_t DoGetMinContinuousUlBandwidth ();
 
   // FFR SAP RRC PROVIDER IMPLEMENTATION
   virtual void DoReportUeMeas (uint16_t rnti, LteRrcSap::MeasResults measResults);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-fr-soft-algorithm.cc ns-3.31/src/lte/model/lte-fr-soft-algorithm.cc
--- ns-3.30.1/src/lte/model/lte-fr-soft-algorithm.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-fr-soft-algorithm.cc	2020-06-27 17:38:30.000000000 -0700
@@ -475,7 +475,7 @@
   return 1;
 }
 
-uint8_t
+uint16_t
 LteFrSoftAlgorithm::DoGetMinContinuousUlBandwidth ()
 {
   NS_LOG_FUNCTION (this);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-fr-soft-algorithm.h ns-3.31/src/lte/model/lte-fr-soft-algorithm.h
--- ns-3.30.1/src/lte/model/lte-fr-soft-algorithm.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-fr-soft-algorithm.h	2020-06-27 17:38:30.000000000 -0700
@@ -78,7 +78,7 @@
   virtual void DoReportUlCqiInfo (const struct FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params);
   virtual void DoReportUlCqiInfo ( std::map <uint16_t, std::vector <double> > ulCqiMap );
   virtual uint8_t DoGetTpc (uint16_t rnti);
-  virtual uint8_t DoGetMinContinuousUlBandwidth ();
+  virtual uint16_t DoGetMinContinuousUlBandwidth ();
 
   // FFR SAP RRC PROVIDER IMPLEMENTATION
   virtual void DoReportUeMeas (uint16_t rnti, LteRrcSap::MeasResults measResults);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-fr-strict-algorithm.cc ns-3.31/src/lte/model/lte-fr-strict-algorithm.cc
--- ns-3.30.1/src/lte/model/lte-fr-strict-algorithm.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-fr-strict-algorithm.cc	2020-06-27 17:38:30.000000000 -0700
@@ -500,7 +500,7 @@
   return 1;
 }
 
-uint8_t
+uint16_t
 LteFrStrictAlgorithm::DoGetMinContinuousUlBandwidth ()
 {
   NS_LOG_FUNCTION (this);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-fr-strict-algorithm.h ns-3.31/src/lte/model/lte-fr-strict-algorithm.h
--- ns-3.30.1/src/lte/model/lte-fr-strict-algorithm.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-fr-strict-algorithm.h	2020-06-27 17:38:30.000000000 -0700
@@ -78,7 +78,7 @@
   virtual void DoReportUlCqiInfo (const struct FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params);
   virtual void DoReportUlCqiInfo ( std::map <uint16_t, std::vector <double> > ulCqiMap );
   virtual uint8_t DoGetTpc (uint16_t rnti);
-  virtual uint8_t DoGetMinContinuousUlBandwidth ();
+  virtual uint16_t DoGetMinContinuousUlBandwidth ();
 
   // FFR SAP RRC PROVIDER IMPLEMENTATION
   virtual void DoReportUeMeas (uint16_t rnti, LteRrcSap::MeasResults measResults);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-interference.h ns-3.31/src/lte/model/lte-interference.h
--- ns-3.30.1/src/lte/model/lte-interference.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-interference.h	2020-06-27 17:38:30.000000000 -0700
@@ -31,13 +31,9 @@
 
 namespace ns3 {
 
-
-
-
 class LteChunkProcessor;
 
 
-
 /**
  * This class implements a gaussian interference model, i.e., all
  * incoming signals are added to the total interference.
@@ -57,22 +53,22 @@
   virtual void DoDispose ();
 
   /**
-   * Add a LteChunkProcessor that will use the time-vs-frequency SINR
+   * \brief Add a LteChunkProcessor that will use the time-vs-frequency SINR
    * calculated by this LteInterference instance. Note that all the
    * added LteChunkProcessors will work in parallel.
    *
    * @param p
    */
-  void AddSinrChunkProcessor (Ptr<LteChunkProcessor> p);
+  virtual void AddSinrChunkProcessor (Ptr<LteChunkProcessor> p);
 
   /**
-   * Add a LteChunkProcessor that will use the time-vs-frequency
-   *  interference calculated by this LteInterference instance. Note 
-   *  that all the added LteChunkProcessors will work in parallel.
+   * \brief Add a LteChunkProcessor that will use the time-vs-frequency
+   * interference calculated by this LteInterference instance. Note
+   * that all the added LteChunkProcessors will work in parallel.
    *
    * @param p
    */
-  void AddInterferenceChunkProcessor (Ptr<LteChunkProcessor> p);
+  virtual void AddInterferenceChunkProcessor (Ptr<LteChunkProcessor> p);
 
   /**
    * Add a LteChunkProcessor that will use the time-vs-frequency
@@ -81,23 +77,21 @@
    *
    * @param p
    */
-  void AddRsPowerChunkProcessor (Ptr<LteChunkProcessor> p);
+  virtual void AddRsPowerChunkProcessor (Ptr<LteChunkProcessor> p);
 
   /**
-   * notify that the PHY is starting a RX attempt
+   * \brief Notify that the PHY is starting a RX attempt
    *
    * @param rxPsd the power spectral density of the signal being RX
    */
-  void StartRx (Ptr<const SpectrumValue> rxPsd);
-
+  virtual void StartRx (Ptr<const SpectrumValue> rxPsd);
 
   /**
    * notify that the RX attempt has ended. The receiving PHY must call
    * this method when RX ends or RX is aborted.
    *
    */
-  void EndRx ();
-
+  virtual void EndRx ();
 
   /**
    * notify that a new signal is being perceived in the medium. This
@@ -107,56 +101,54 @@
    * @param spd the power spectral density of the new signal
    * @param duration the duration of the new signal
    */
-  void AddSignal (Ptr<const SpectrumValue> spd, const Time duration);
-
+  virtual void AddSignal (Ptr<const SpectrumValue> spd, const Time duration);
 
   /**
    *
    * @param noisePsd the Noise Power Spectral Density in power units
    * (Watt, Pascal...) per Hz.
    */
-  void SetNoisePowerSpectralDensity (Ptr<const SpectrumValue> noisePsd);
+  virtual void SetNoisePowerSpectralDensity (Ptr<const SpectrumValue> noisePsd);
 
-private:
+protected:
   /**
-   * Considitionally evaluate chunk
+   * Conditionally evaluate chunk
    */
-  void ConditionallyEvaluateChunk ();
+  virtual void ConditionallyEvaluateChunk ();
   /**
    * Add signal function
    *
    * @param spd the power spectral density of the new signal
    */
-  void DoAddSignal  (Ptr<const SpectrumValue> spd);
+  virtual void DoAddSignal (Ptr<const SpectrumValue> spd);
   /**
    * Subtract signal
    *
    * @param spd the power spectral density of the new signal
    * @param signalId the signal ID
    */
-  void DoSubtractSignal  (Ptr<const SpectrumValue> spd, uint32_t signalId);
-
-
+  virtual void DoSubtractSignal (Ptr<const SpectrumValue> spd, uint32_t signalId);
 
-  bool m_receiving; ///< are we receiving?
+  bool m_receiving {false}; ///< are we receiving?
 
-  Ptr<SpectrumValue> m_rxSignal; /**< stores the power spectral density of
-                                  * the signal whose RX is being
-                                  * attempted
-                                  */
+  Ptr<SpectrumValue> m_rxSignal {nullptr}; /**< stores the power spectral density of
+                                            * the signal whose RX is being
+                                            * attempted
+                                            */
 
-  Ptr<SpectrumValue> m_allSignals; /**< stores the spectral
-                                    * power density of the sum of incoming signals;
-                                    * does not include noise, includes the SPD of the signal being RX
-                                    */
+  Ptr<SpectrumValue> m_allSignals {nullptr}; /**< stores the spectral
+                                              * power density of the sum of incoming signals;
+                                              * does not include noise, includes the SPD of the signal being RX
+                                              */
 
-  Ptr<const SpectrumValue> m_noise; ///< the noise value
+  Ptr<const SpectrumValue> m_noise {nullptr}; ///< the noise value
 
-  Time m_lastChangeTime;     /**< the time of the last change in
-                                m_TotalPower */
+  Time m_lastChangeTime {Seconds(0)}; /**< the time of the last change in
+                                       * m_TotalPower
+                                       */
 
-  uint32_t m_lastSignalId; ///< the last signal ID
-  uint32_t m_lastSignalIdBeforeReset; ///< the last signal ID before reset
+  uint32_t m_lastSignalId {0}; ///< the last signal ID
+  uint32_t m_lastSignalIdBeforeReset {0}; ///< the last signal ID before reset
 
   /** all the processor instances that need to be notified whenever
   a new interference chunk is calculated */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-phy.h ns-3.31/src/lte/model/lte-phy.h
--- ns-3.30.1/src/lte/model/lte-phy.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-phy.h	2020-06-27 17:38:30.000000000 -0700
@@ -266,12 +266,12 @@
    * The UL bandwidth in number of PRBs.
    * Specified by the upper layer through CPHY SAP.
    */
-  uint8_t m_ulBandwidth;
+  uint16_t m_ulBandwidth;
   /**
    * The DL bandwidth in number of PRBs.
    * Specified by the upper layer through CPHY SAP.
    */
-  uint8_t m_dlBandwidth;
+  uint16_t m_dlBandwidth;
   /// The RB group size according to the bandwidth.
   uint8_t m_rbgSize;
   /**
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-rlc-um.cc ns-3.31/src/lte/model/lte-rlc-um.cc
--- ns-3.30.1/src/lte/model/lte-rlc-um.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-rlc-um.cc	2020-06-27 17:38:30.000000000 -0700
@@ -63,6 +63,11 @@
                    UintegerValue (10 * 1024),
                    MakeUintegerAccessor (&LteRlcUm::m_maxTxBufferSize),
                    MakeUintegerChecker<uint32_t> ())
+    .AddAttribute ("ReorderingTimer",
+                   "Value of the t-Reordering timer (See section 7.3 of 3GPP TS 36.322)",
+                   TimeValue (MilliSeconds (100)),
+                   MakeTimeAccessor (&LteRlcUm::m_reorderingTimerValue),
+                   MakeTimeChecker ())
     ;
   return tid;
 }
@@ -558,7 +563,7 @@
         {
           NS_LOG_LOGIC ("VR(UH) > VR(UR)");
           NS_LOG_LOGIC ("Start reordering timer");
-          m_reorderingTimer = Simulator::Schedule (Time ("0.1s"),
+          m_reorderingTimer = Simulator::Schedule (m_reorderingTimerValue,
                                                    &LteRlcUm::ExpireReorderingTimer ,this);
           m_vrUx = m_vrUh;
           NS_LOG_LOGIC ("New VR(UX) = " << m_vrUx);
@@ -1173,7 +1178,7 @@
   if ( m_vrUh > m_vrUr)
     {
       NS_LOG_LOGIC ("Start reordering timer");
-      m_reorderingTimer = Simulator::Schedule (Time ("0.1s"),
+      m_reorderingTimer = Simulator::Schedule (m_reorderingTimerValue,
                                                &LteRlcUm::ExpireReorderingTimer, this);
       m_vrUx = m_vrUh;
       NS_LOG_LOGIC ("New VR(UX) = " << m_vrUx);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-rlc-um.h ns-3.31/src/lte/model/lte-rlc-um.h
--- ns-3.30.1/src/lte/model/lte-rlc-um.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-rlc-um.h	2020-06-27 17:38:30.000000000 -0700
@@ -141,6 +141,7 @@
   /**
    * Timers. See section 7.3 in TS 36.322
    */
+  Time    m_reorderingTimerValue; ///< reordering timer value
   EventId m_reorderingTimer; ///< reordering timer
   EventId m_rbsTimer; ///< RBS timer
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-rrc-header.cc ns-3.31/src/lte/model/lte-rrc-header.cc
--- ns-3.30.1/src/lte/model/lte-rrc-header.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-rrc-header.cc	2020-06-27 17:38:30.000000000 -0700
@@ -74,7 +74,7 @@
 }
 
 int
-RrcAsn1Header::BandwidthToEnum (uint8_t bandwidth) const
+RrcAsn1Header::BandwidthToEnum (uint16_t bandwidth) const
 {
   int n;
   switch (bandwidth)
@@ -86,15 +86,15 @@
       case 75: n = 4; break;
       case 100: n = 5; break;
       default:
-        NS_FATAL_ERROR ("Wrong bandwidth: " << (uint16_t) bandwidth);
+        NS_FATAL_ERROR ("Wrong bandwidth: " << bandwidth);
     }
   return n;
 }
 
-uint8_t
+uint16_t
 RrcAsn1Header::EnumToBandwidth (int n) const
 {
-  uint8_t bw;
+  uint16_t bw;
   switch (n)
     {
       case 0: bw = 6; break;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-rrc-header.h ns-3.31/src/lte/model/lte-rrc-header.h
--- ns-3.30.1/src/lte/model/lte-rrc-header.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-rrc-header.h	2020-06-27 17:38:30.000000000 -0700
@@ -72,14 +72,14 @@
    * \param bandwidth Bandwidth in RBs: 6, 15, 25, 50, 75, 100
    * \returns ENUMERATED value: 0, 1, 2, 3, 4, 5
    */
-  int BandwidthToEnum (uint8_t bandwidth) const;
+  int BandwidthToEnum (uint16_t bandwidth) const;
   /**
    * Convert from ENUMERATED value to bandwidth (in RBs)
    *
    * \param n ENUMERATED value: 0, 1, 2, 3, 4, 5
    * \returns bandwidth Bandwidth in RBs: 6, 15, 25, 50, 75, 100
    */
-  uint8_t EnumToBandwidth (int n) const;
+  uint16_t EnumToBandwidth (int n) const;
 
 
   // Serialization functions
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/model/lte-rrc-protocol-real.cc ns-3.31/src/lte/model/lte-rrc-protocol-real.cc
--- ns-3.30.1/src/lte/model/lte-rrc-protocol-real.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/model/lte-rrc-protocol-real.cc	2020-06-27 17:38:30.000000000 -0700
@@ -549,11 +549,12 @@
               if (ueRrc->GetCellId () == cellId)
                 {
                   NS_LOG_LOGIC ("sending SI to IMSI " << ueDev->GetImsi ());
-                  ueRrc->GetLteUeRrcSapProvider ()->RecvSystemInformation (msg);
-                  Simulator::Schedule (RRC_REAL_MSG_DELAY, 
-                                       &LteUeRrcSapProvider::RecvSystemInformation,
-                                       ueRrc->GetLteUeRrcSapProvider (), 
-                                       msg);
+
+                  Simulator::ScheduleWithContext (node->GetId (),
+                                                  RRC_REAL_MSG_DELAY,
+                                                  &LteUeRrcSapProvider::RecvSystemInformation,
+                                                  ueRrc->GetLteUeRrcSapProvider (),
+                                                  msg);
                 }
             }
         }
